
/*  @(#)ertf2latex.c 1.3 95/07/07
 *
 *  Copyright (c) Mikael Cam.
 *                All rights reserved.
 *
 *  Permission is given to distribute these sources, as long as the
 *  copyright messages are not removed, and no monies are exchanged.
 *
 *  No responsibility is taken for any errors inherent either
 *  to the comments or the code of this program, but if reported
 *  to me then an attempt will be made to fix them.
 */

#include "ertf2latex.h"
char *usage = "Usage: ertf2latex input_file [-onlybody]\n";

char taille_car = 4;
char affiche = True;
char after_style = False;

void taille(void)
{
  /* To put the right character size */
  switch (taille_car)
    {
    case 0: fprintf(stdout, "%s", TAILLE0); break;
    case 1: fprintf(stdout, "%s", TAILLE1); break;
    case 2: fprintf(stdout, "%s", TAILLE2); break;
    case 3: fprintf(stdout, "%s", TAILLE3); break;
    case 4: fprintf(stdout, "%s", TAILLE4); break;
    case 5: fprintf(stdout, "%s", TAILLE5); break;
    case 6: fprintf(stdout, "%s", TAILLE6); break;
    case 7: fprintf(stdout, "%s", TAILLE7); break;
    case 8: fprintf(stdout, "%s", TAILLE8); break;
    case 9: fprintf(stdout, "%s", TAILLE9); break;
    }
  
}


void MACRO_1(void)
{

  if (taille_car < 9) taille_car ++;
  taille();

}

void MACRO_2(void)
{

  if (taille_car > 0) taille_car --;
  taille();

}

void MACRO_5(void)
{

  if (taille_car > 0) taille_car --;
  fprintf(stdout, "%c", FIN_BLOC);
}

void MACRO_6(void)
{

  if (taille_car < 9) taille_car ++;
  fprintf(stdout, "%c", FIN_BLOC);
}


void MACRO_3(void)
{

  affiche = False;

}

void MACRO_4(void)
{

  affiche = True;

}

void style(int styl)
{
/* Outputs the right style */
  switch(styl)
    {
    case 1: fprintf(stdout, "%s", BOLD); break;
    case 2: fprintf(stdout, "%s", ITALIC); break;
    case 3: fprintf(stdout, "%s", FIXED); break;
    }
  after_style = True;

}

void Appel_Macro (int no_macro)
{
  switch (no_macro)
    {
    case 1: if (affiche) MACRO_1(); break;
    case 2: if (affiche) MACRO_2(); break;
    case 3: MACRO_3(); break;
    case 4: MACRO_4(); break;
    case 5: MACRO_5(); break;
    case 6: MACRO_6(); break;
    case 7: style(1); break;
    case 8: style(2); break;
    case 9: style(3); break;


    }
}

void entete(void)

/* to produce an entire LaTeX document, outputs the prologue of this document... */

{

P("\\documentclass [a4paper,12pt] {article}");
P("\\usepackage{graphics}");
P("\\usepackage{moreverb}");

P("\\newenvironment{ident}{\\begin{list}%");
P("{}{\\rightmargin=0mm}\\item[]}%");
P("{\\end{list}}");

P("\\newenvironment{indentright}{\\begin{list}%");
P("{}{\\rightmargin=\\leftmargin%");
P("\\leftmargin=0mm}\\item[]}%");
P("{\\end{list}}");

P("\\newenvironment{nofill}{\\parindent=0mm\\obeylines}{\\par}");

P("\\begin{document}");

  


}


void piedpage(void)

/* same with the end of the document */

{

P("\\end{document}");

}

char *strtolower(char *src_str)

/* Converts a string into lower case.
 * Returns a pointer to this string...
 */

{
  char *tgt_str;
  int  j;


      tgt_str = (char *) malloc(sizeof(char) * (strlen (src_str) + 1));
      for(j = 0; j < strlen(src_str); j++)
	{
	  if (isupper((int)(*(src_str + j))))
	    tgt_str[j] = (char)tolower((int)(*(src_str + j)));
	  else
	    tgt_str[j] = *(src_str + j);
	}
      tgt_str[j] = '\0';
  return (tgt_str);


}


int convert (char *filename)
{

  char *ERR[] = {
                "Erreur lors de l'ouverture du fichier source\n",
		"Erreur de syntaxe...\n",  
		"Erreur grammaticale...\n"  
	       };	  

/* The text/enriched commands with their translations in LaTeX */

  char *corresp[] = {
                     "<underline>",        "\\underline{",
		     "</underline>",       "}",
		     "<bold>",             "MACRO_7",
		     "</bold>",            "}",
                     "<italic>",           "MACRO_8",
                     "</italic>",          "}",
		     "<fixed>",            "MACRO_9",
		     "</fixed>",           "}",
		     "<center>",           "\\begin{center}",
		     "</center>",          "\\end{center}",
		     "<flushleft>",        "\\begin{flushleft}",
		     "</flushleft>",       "\\end{flushleft}",
		     "<flushright>",       "\\begin{flushright}",
		     "</flushright>",      "\\end{flushright}",
		     "<flushboth>",        "",
		     "</flushboth>",       "",
		     "<nofill>",           "\\begin{nofill}",
		     "</nofill>",          "\\end{nofill}",
		     "<indent>",           "\\begin{indent}",
		     "</indent>",          "\\end{indent}",
		     "<indentright>",      "\\begin{indentright}",
		     "</indentright>",     "\\end{indentright}",
		     "<<",                 "$<$",
		     "<bigger>",           "MACRO_1",
		     "</bigger>",          "MACRO_5",
		     "<smaller>",          "MACRO_2",
		     "</smaller>",         "MACRO_6",
		     "<param>",            "MACRO_3",
		     "</param>",           "MACRO_4",
                     NULL,                 NULL 
		   };


/* the special symbols of LaTeX and the elements which may replace them */

  char *specar[] = {
                     "$",                  "\\$",
		     "&",                  "\\&",
		     "%",                  "\\%",
		     "#",                  "\\#",
		     "_",                  "\\_",
		     "{",                  "\\{",
		     "}",                  "\\}",
		     "\\",                 "$\\backslash$",
		     "|",                  "$|$",
		     "<",                  "$<$",
		     ">",                  "$>$",
		     "~",                  "$\\sim$",
		     "^",                  "$\\wedge$",
		     NULL,                 NULL
		   };


  FILE *fp;    /* pointer on the source file */
  char carcour;
  char buffer[256];
  int  buf_ind = 0;
  int i, j, k;
  int ind = 0;
  char trouve;
  char ERREUR;
  char fin_com;
  format_com *comm;
  format_com *com_cour;
  Liste_com  l;
  int nbCRLF;
  char etatCRLF = False;

  /* if (_TRACE) for ( i = 0; corresp[i]; i++) printf("%s\n", corresp[i]); */




  if(!strcmp(filename, "stdin")) fp = stdin;  
  else
/* if the input is not the standard one, opens the source file (in text/enriched) */
  if (!(fp = fopen(filename, "r"))) {
                                    fprintf(stderr, "%s", ERR[0]);
				    fprintf(stderr, "%s", usage);
				    exit(1);
				   } 

 if (_TRACE) T("Fichier ouvert!");

/* creates a list in which will be stored the "last commands" */

  CreeListe (&l);
     
/* Reads each character in the source file */

      while ((fscanf (fp, "%c", &carcour)) != EOF) {
	 

/* does it look like the beginning of a text/enriched command ? */
      if (carcour == '<')  
/* yes, it does ... */
	{
	  *(buffer+buf_ind) = carcour;
	  *(buffer+buf_ind+1) = '\0';
	  buf_ind ++;
	  
	  
	  if ((fscanf (fp, "%c", &carcour)) != EOF)
	    if (carcour != '<')
	      {
		*(buffer+buf_ind) = carcour; /* stores the current character in the buffer */
		*(buffer+buf_ind+1) = '\0';
		buf_ind ++;

/* does it look like the end of a text/enriched command ? */
		if (carcour == '>') fin_com = True;  /* Yes, it does */
		else
		  fin_com = False;                   /* No, it doesn't */

/* reads each character of the source file until it finds either the end of the command or the end of the file */ 
		while ((!fin_com) && ((fscanf (fp, "%c", &carcour)) != EOF))
		  {
		    if (buf_ind < 61) 
		      {
			*(buffer+buf_ind) = carcour; /* stores the character in the buffer */
			*(buffer+buf_ind+1) = '\0';
			buf_ind ++;
			if (_TRACE) fprintf(stderr, "buffer: %s\n", buffer);
		      }
		    
		    
		    else
		      {
			ERREUR = True;  /* if the buffer exceeds 60 characters and no end of command was found */
			if (affiche) fprintf(stdout, "%s", buffer);
			fprintf(stderr, "%s", ERR[1]);
			fprintf(stderr, "Fin de commande introuvable: %s\n", buffer);
			buf_ind = 0;
			break;
		      }
		    
/* does it look like the end of a text/enriched command ? */
		    if (carcour == '>') fin_com = True;
		    /* Yes, it does */
		  }
		
		if (fin_com) 
		  {
		    
		    trouve = False;
		    
		    
		    
		    if (_TRACE) fprintf(stderr, "Indice: %d\n", ind);
		    
		    
		    ind = 0;
/* Is this a text/enriched command ? */

		    while ((corresp[ind]) && (!trouve))
		      {
			if (!strcmp(corresp[ind], strtolower(buffer))) trouve = True;
			if (!trouve) ind += 2;
		      }
		    
		    
		    if (!trouve) /* No, it isn't ! */
		      {
			buf_ind = 0;
			ERREUR = True;
			fprintf(stderr, "%s", ERR[1]);
			fprintf(stderr, "La commande: %s n'existe pas dans le format enriched/text\n", buffer); 
		      }
		    
		    else
		      {
			/* It is a text/enriched command ! */
			if(*(buffer + 1) != '/') /* Is this the end of a block (block = <bold> text </bold> ) */ 
			      {
				/* No, it isn't the end of a block ! */
				if (!strncmp(corresp[ind+1], MACRO, strlen(MACRO))) /* do we have to call a MACRO command ? */
			  Appel_Macro(atoi(corresp [ind+1] + strlen(MACRO))) ; /* Yes, call the MACRO ! */
			else
			  fprintf(stdout, "%s", corresp[ind+1]);           /* No, replace with the corresponding element */
			comm = (format_com*) malloc (sizeof(format_com));
			remplie_comm (comm, strtolower(buffer), &l);       /* Stores the command in the list */ 
			AjouteListe (&l, comm);
		      }
			    else
			      /* Yes, it is the end of a block ! */
			      {
				 if (corresp[ind-2]) {
				  
				  if (com_cour = Trouve(corresp[ind-2], &l))  /* Do we have the beginning of the block in the list ? */
				    {
				      /* Yes, we do ! */
				      OteEltListe (&l, com_cour); /* removes the element from the list */ 
			if (!strncmp(corresp[ind+1], MACRO, strlen(MACRO)))
			  Appel_Macro(atoi(corresp [ind+1] + strlen(MACRO))) ;
			else
			  fprintf(stdout, "%s", corresp[ind+1]);
				    }
				  else
				    /* No, we don't have the beginning of the block in the list */
				    {
				      fprintf(stderr, "%s", ERR[2]);
				      fprintf(stderr, "%s manquant!\n", corresp[ind-2]);
				      ERREUR = True;
				    } 
				} 
			      }

			
			buf_ind = 0;
			
		      }
		    
		  }
	      
	      }
	}
	    else
	  /* No, we are not in a command (it doesn't look like the beginning o a command) */    
		{

		  k = 0;
		  trouve = False;

		  while ((specar[k]) && (!trouve)) 
		    {
		      /* Warning, it is a LaTeX special symbol ! */
		      if (((char)*specar[k] == carcour) && (affiche) && (specar[k+1]))
			{
			  fprintf(stdout, "%s", specar[k+1]); 
			  trouve = True;
			}
		      if (!trouve) k += 2;
		    }
		  if ((carcour == SPACE) && (after_style)) 
		    {
		      fprintf(stdout, "%s", BLOC); 
		      after_style = False;
		    }

		  if ((!trouve) && (affiche)) fprintf (stdout, "%c", carcour);
		}
    }

/* It is the end of the document */
/* Are all the blocks closed ? */

  while (!FinListe(&l))
/* Closes the blocks */
    {
     com_cour = position_tete (&l);
		    ind = 0;
                    trouve = False;
		    while ((corresp[ind]) && (!trouve))
		      {
			if (!strcmp(corresp[ind]+2, strtolower(com_cour->c_name+1))) trouve = True;
			if (!trouve) ind += 2;
		      }

      if (!trouve) fprintf(stdout, "%c", FIN_BLOC);
      else
	fprintf(stdout, "%s", corresp[ind+1]);
	
       OteEltListe (&l, com_cour);
      
    }

  }

int main(int argc, char *argv[])
{
  char ONLYBODY;
  char fichier[50];

/* Analysis of the command line (from stdin or from file, etc. ?) */
  switch (argc)
    {
    case 1: strcpy(fichier, "stdin"); break;
    case 2: if(!strcmp(argv[1], "-onlybody"))
      {
	ONLYBODY = True;
	strcpy(fichier, "stdin");
      }
    else
      {
	strcpy(fichier, argv[1]);
	ONLYBODY = False;
      }
      break;
      
    case 3: if(!strcmp(argv[1], "-onlybody"))
      {
	ONLYBODY = True;
	strcpy(fichier, argv[2]);
      }
      else
	if (!strcmp(argv[2], "-onlybody"))
	  {
	    ONLYBODY = True;
	    strcpy(fichier, argv[1]);
	  }
	  else
	    {
	      fprintf(stderr, "%s", usage);
	      exit(1);
	    }
      break;
    default: fprintf(stderr, "%s", usage); exit(1);

    }



  
  if (!ONLYBODY) entete();  
  convert(fichier);          /* Translates the text/enriched source into LaTeX */
  if (!ONLYBODY) piedpage();

}








