
/*  @(#)input.h 1.5 95/02/06
 *
 *  Contains definitions for class "Input".
 *
 *  Copyright (c) Steve Holden and Rich Burridge.
 *                All rights reserved.
 *
 *  Permission is given to distribute these sources, as long as the
 *  copyright messages are not removed, and no monies are exchanged.
 *
 *  No responsibility is taken for any errors or inaccuracies inherent
 *  either to the comments or the code of this program, but if
 *  reported to me then an attempt will be made to fix them.
 */

typedef enum { DO_MAIL, DO_NEWS, DO_TEXT } document_type ;

extern char *owner ;           /* Name of owner (usually equal to 'to') */

extern char *current_line      (void) ;
extern char *get_line          (void) ;
extern char *who_am_i          (void) ;

extern document_type doc_type  (void) ;

extern int line_len            (void) ;
extern int message_len         (void) ;
extern int end_of_file         (void) ;
extern int end_of_line         (void) ;
extern int end_of_page         (void) ;

extern void close_input        (void) ;
extern void Input              (void) ;
extern void init_setup         (void) ;
extern void readline           (void) ;
extern void set_doc_type       (document_type) ;
extern void set_eof            (int) ;
extern void set_eop            (int) ;
extern void set_input          (FILE *) ;
extern void set_line_number    (int) ;
extern void set_message_len    (int) ;
